program pampam;

uses crt,dos,graf19,memory;

const vihulimit=20;

type
 ammuslista=^ammus;
 ammus=record
        x,y:integer;
        ohjus:boolean;
        next:ammuslista;
       end;
 maalityyppi=(vihu,alyvihu,bomber,paha,ase,missile,pallo,kukka,panssari,luiska,sydan);
 maalilista=^maali;
 maali=record
        x,y,korkeus:integer;
        explode:integer;
        laji:maalityyppi;
        next:maalilista;
       end;

var
 vanhanappis:procedure;
 p,old_exit_proc:pointer;
 patit,pommit:ammuslista;
 x_laiva,y_laiva,ammo,lapi,maara,raja:integer;
 ammobonus,pistebonus,arparaja,level,leimahdus,leimahdusraja:integer;
 pistemaara:longint;
 gun_active,l_vasen,l_oikea,paussi,breikki:boolean;
 aika:byte;
 viholliset:maalilista;
 korkeudet,kertoimet,sakot,arvat: array [maalityyppi] of integer;
 vihukuva:array [maalityyppi] of pointer;
 vihupic:file;
 puskuri,tausta,isofontti,pikkufontti,ohjuskuva:pointer;
 puskuriseg,taustaseg:word;
 tulos:string;
 level_data:text;
 puupaa:char;

procedure lisaa_ammus(var tahan:ammuslista;x,y:integer;jarea:boolean);
var apu2:ammuslista;
begin
 apu2:=NIL;
 new(apu2);
 if apu2=NIL then
 begin
  tekstitila;
  setintvec($09,@vanhanappis);
  writeln('Ammuksen lisminen ei onnistunut');
  halt(1)
 end;
 apu2^.next:=tahan;
 apu2^.ohjus:=jarea;
 apu2^.x:=x;
 apu2^.y:=y;
 tahan:=apu2;
end;

procedure lisaa_maali(kx,ky:integer; laatu:maalityyppi);
var apu2:maalilista;
begin
 if maxavail<500 then
 begin
  tekstitila;
  setintvec($09,@vanhanappis);
  writeln('Muisti loppui');
  halt(1);
 end;
 apu2:=NIL;
 new(apu2);
 if apu2=NIL then
 begin
  tekstitila;
  setintvec($09,@vanhanappis);
  writeln('Maalin lisminen ei onnistunut');
  halt(1)
 end;
 apu2^.next:=viholliset;
 apu2^.x:=kx;
 apu2^.y:=ky;
 apu2^.laji:=laatu;
 apu2^.korkeus:=korkeudet[laatu];
 apu2^.explode:=0;
 if laatu=panssari then apu2^.explode:=-4;
 if laatu=luiska then apu2^.explode:=-10;
 if laatu=sydan then apu2^.explode:=-20;
 viholliset:=apu2;
end;

procedure poista_pati(var tama:ammuslista;var tasta:ammuslista);
var apu:ammuslista;
begin
 if (tasta<>nil) and (tama<>nil) then
 begin
  if tama=tasta then
  begin
   tasta:=tasta^.next;
   dispose(tama);
  end
  else
  begin
   apu:=tasta;
   while (apu^.next<>tama) and (apu^.next<>NIL) do
   begin
    apu:=apu^.next
   end;
   if apu^.next=tama then
   begin
    apu^.next:=tama^.next;
    dispose(tama);
   end
   else
   begin
    tekstitila;
    setintvec($09,@vanhanappis);
    writeln('ammuslista vaurioitunut');
    halt(1);
   end;
  end
 end
 else
 begin
    tekstitila;
    setintvec($09,@vanhanappis);
    writeln('yritys poistaa tyhjaa ammusta tai tyhjasta ammuslistasta');
    halt(1);
 end;
end;

procedure poista_maalit;
var apu1,apu2,apu3:maalilista;
begin
 apu1:=NIL;
 apu2:=viholliset;
 while apu2<>NIL do
 begin
  apu3:=apu2^.next;
  if (apu2^.y>185) or (apu2^.explode>40) then
  begin
   if apu1<>NIL then apu1^.next:=apu2^.next
   else viholliset:=viholliset^.next;
   dispose(apu2);
  end
  else
  begin
   if apu1=NIL then apu1:=viholliset else apu1:=apu1^.next;
  end;
  apu2:=apu3;
 end;
end;

procedure piirra_alus(x,y:integer);
begin
 xsuora(x-6,y,13,$2c);
 xsuora(x-6,y+1,13,$2c);
 ysuora(x,y-3,4,$2c);
end;

procedure piirra_pati(x,y:integer;jarea:boolean);
begin
 if not jarea then ysuora(x,y,2,$1c)
 else movnz_piirra(x-2,y-2,ohjuskuva);
end;

procedure piirra_pommi(x,y:integer);
begin
 ysuora(x,y,2,$29);
end;

procedure piirra_maali(var tama:maalilista);
var kx,ky,i,raja,x,y:integer;vari:byte;
begin
 kx:=tama^.x;
 ky:=tama^.y;
 case tama^.laji of
  vihu:vari:=$28;
  alyvihu:vari:=$2f;
  bomber:vari:=$20;
  paha:vari:=$84;
  ase:vari:=$2c;
  missile:vari:=$1f;
  pallo:vari:=$64;
  kukka:vari:=$29;
  panssari:vari:=$19;
  luiska:vari:=$00;
  sydan:vari:=$2f;
 end;
 if tama^.explode<=0 then
  movnz_piirra(kx-6,ky,vihukuva[tama^.laji])
 else
 begin
  raja:=3+(tama^.explode div 5);
  for i:=20 downto raja-3 do
  begin
   x:=kx-raja+random(2*raja);
   y:=ky-raja+random(2*raja);
   piirrapiste(x,y,vari);
  end;
  inc(tama^.explode);
 end;
end;

procedure piirra_tilanne;
var apu:ammuslista; vihut,apum:maalilista; score:string; i,koko:integer;
begin
 move(mem[taustaseg:$0000],mem[puskuriseg:$0000],64000);
 aseta_puskuri(puskuriseg);
 piirra_alus(x_laiva,y_laiva);
 apu:=patit;
 while apu<>NIL do
 begin
  piirra_pati(apu^.x,apu^.y,apu^.ohjus);
  apu:=apu^.next;
 end;
 apu:=pommit;
 while apu<>NIL do
 begin
  piirra_pommi(apu^.x,apu^.y);
  apu:=apu^.next;
 end;
 vihut:=viholliset;
 while vihut<>NIL do
 begin
  apum:=vihut^.next;
  piirra_maali(vihut);
  vihut:=apum;
 end;
 koko:=5+(leimahdus div 6);
 if leimahdus>0 then
 for i:=1 to leimahdusraja-leimahdus do
 begin
  piirrapiste(x_laiva-koko+random(2*koko),y_laiva-random(koko),$2c)
 end;
 str(pistemaara:5,score);
 outtextXY(280,0,score,$63);
 suorakaide(0,198,ammo div 10,199,$3d);
 suorakaide(235+4*lapi,198,315,199,$2c);
 ruutu;
 aseta_puskuri(SegA000);
end;

{$F+}
procedure omanappis; Interrupt;
var tavu:byte;
begin
    asm
     push ax
     xor ax, ax
     in  al, $60
     mov tavu, al
     mov al, $20
     out $20, al
     pop ax
    end;
    if paussi then paussi:=false;
    case tavu of
    129:breikki:=true;
    153:paussi:=true;
    75:begin
        l_vasen:=true;
        l_oikea:=false;
       end;
    203:l_vasen:=false;
    77:begin
        l_oikea:=true;
        l_vasen:=false;
       end;
    205:l_oikea:=false;
    57:if gun_active then
       begin
        if ammo>0 then lisaa_ammus(patit,x_laiva,y_laiva-4,false);
        gun_active:=false;
        if ammo>0 then dec(ammo);
       end;
    50:if gun_active and (ammo>9) then
       begin
        lisaa_ammus(patit,x_laiva,y_laiva-4,true);
        gun_active:=false;
        ammo:=ammo-10;
       end;
    178,185:gun_active:=true;
    end;
end;
{$F-}

procedure kelaa_patit(var nama:ammuslista);
var apu1,apu2:ammuslista;apum,apum2:maalilista;huti:boolean;
    kerroin,raja,et,teho:integer;
begin
 apu1:=nama;
 while apu1<>NIL do
 begin
  apu2:=apu1^.next;
  apu1^.y:=apu1^.y-3;
  if apu1^.y<0 then poista_pati(apu1,nama);
  apum:=viholliset;
  huti:=true;
  while (apum<>NIL) and huti do
  begin
   raja:=6;
   if apum^.laji=missile then raja:=4;
   if (apu1^.y>=apum^.y) and (apu1^.y<apum^.y+apum^.korkeus) and (abs(apu1^.x-apum^.x)<=raja) then
   begin
    if apu1^.ohjus then
    begin
     apum2:=viholliset;
     while apum2<>NIL do
     begin
      et:=abs(apum2^.x-apu1^.x)+abs(apum2^.y-apu1^.y);
      teho:=12-(et div 5);
      if et<56 then
      begin
       if (teho+apum2^.explode>0) and (apum2^.explode<=0) then
        pistemaara:=pistemaara+kertoimet[apum^.laji]*(200-apum^.y);
       apum2^.explode:=apum2^.explode+teho;
      end;
      apum2:=apum2^.next
     end
    end;
    poista_pati(apu1,nama);
    huti:=false;
    if apum^.explode<=0 then
    begin
     inc(apum^.explode);
     if apum^.explode>0 then pistemaara:=pistemaara+kertoimet[apum^.laji]*(200-apum^.y);
    end;
   end;
   apum:=apum^.next;
  end;
  apu1:=apu2;
 end;
end;

procedure kelaa_pommit(var nama:ammuslista);
var apu1,apu2:ammuslista;
begin
 apu1:=nama;
 while apu1<>NIL do
 begin
  apu2:=apu1^.next;
  apu1^.y:=apu1^.y+3;
  if apu1^.y>196 then
  begin
   if abs(x_laiva-apu1^.x)<=6 then
   begin
    ammo:=ammo-10;
    pistemaara:=pistemaara-500;
    if ammo<0 then ammo:=0;
    leimahdusraja:=18;
    leimahdus:=1;
   end;
   poista_pati(apu1,nama);
  end;
  apu1:=apu2;
 end;
end;

procedure liikuta;
var apu,apu2:maalilista;
    i,minimi,diff,siirto:integer;
    ammukset:ammuslista;
    laatu:maalityyppi;
begin
 apu:=viholliset;
 while apu<>NIL do
 begin
  apu2:=apu^.next;
  laatu:=apu^.laji;
  case laatu of
  missile:begin
           apu^.y:=apu^.y+2;
           i:=0;
           if apu^.explode=0 then
           begin
            if apu^.x>x_laiva+6 then i:=-2
            else if apu^.x<x_laiva-6 then i:=2
           end;
           i:=i-2+random(5);
           apu^.x:=apu^.x+i;
           if apu^.x>312 then apu^.x:=312;
           if apu^.x<8 then apu^.x:=8;
           if (apu^.y>185) then
           begin
            if (abs(apu^.x-x_laiva)<=6) and (apu^.explode<10) then
            begin
             pistemaara:=pistemaara-100*(10-apu^.explode);
             ammo:=ammo-10*(10-apu^.explode);
             if ammo<0 then ammo:=0;
             leimahdusraja:=36;
             leimahdus:=1;
            end;
           end;
          end;
  vihu,bomber,ase: begin
                    i:=random(3);
                    case i of
                    0:apu^.x:=apu^.x-2;
                    1:apu^.x:=apu^.x+2;
                    2:inc(apu^.y);
                    end;
                    if apu^.x<8 then apu^.x:=8;
                    if apu^.x>312 then apu^.x:=312;
                    if apu^.y>185 then
                    begin
                     if apu^.explode=0 then
                     begin
                      if (apu^.laji=ase) and (abs(apu^.x-x_laiva)<=10) then ammo:=ammo+40;
                      lapi:=lapi+sakot[apu^.laji];
                     end;
                    end;
                   end;
  alyvihu,paha,kukka:begin
                      ammukset:=patit;
                      siirto:=0;
                      minimi:=320;
                      while ammukset<>NIL do
                      begin
                       diff:=ammukset^.x-apu^.x;
                       if abs(diff)<minimi then
                       begin
                        minimi:=abs(diff);
                        if minimi<50 then
                        begin
                         if diff<0 then siirto:=2
                         else siirto:=-2;
                        end;
                       end;
                       ammukset:=ammukset^.next;
                      end;
                      i:=random(5);
                      case i of
                       0:apu^.x:=apu^.x-2;
                       1:apu^.x:=apu^.x+2;
                       2:inc(apu^.y);
                       3,4:apu^.x:=apu^.x+siirto;
                      end;
                      if apu^.x<10 then apu^.x:=10;
                      if apu^.x>310 then apu^.x:=310;
                      if apu^.y>185 then
                      begin
                       if apu^.explode=0 then lapi:=lapi+sakot[apu^.laji];
                      end;
                     end;
  pallo,panssari,luiska,sydan:begin
                  ammukset:=patit;
                  siirto:=0;
                  minimi:=320;
                  while ammukset<>NIL do
                  begin
                   diff:=ammukset^.x-apu^.x;
                   if (abs(diff)<minimi) and (ammukset^.y>=apu^.y) then
                   begin
                    minimi:=abs(diff);
                    if minimi<50 then
                    begin
                     if diff<0 then siirto:=2
                     else siirto:=-2;
                    end;
                   end;
                   ammukset:=ammukset^.next;
                  end;
                  i:=random(5);
                  case i of
                   0:apu^.x:=apu^.x-2;
                   1:apu^.x:=apu^.x+2;
                   2:inc(apu^.y);
                   3,4:apu^.x:=apu^.x+siirto;
                  end;
                  if apu^.x<10 then apu^.x:=10;
                  if apu^.x>310 then apu^.x:=310;
                  if apu^.y>185 then
                  begin
                   if apu^.explode<=0 then lapi:=lapi+sakot[apu^.laji];
                  end;
                 end;
  end;
  apu:=apu2;
 end;
 if lapi>vihulimit then lapi:=vihulimit;
end;

procedure uudet;
var apu1,apu2:maalilista; i:integer;
begin
 apu1:=viholliset;
 while apu1<>NIL do
 begin
  apu2:=apu1^.next;
  if (apu1^.laji IN [pallo,kukka,panssari,luiska,sydan]) and (apu1^.explode<=0) then
  begin
   i:=apu1^.x+6;
   if i>312 then i:=312;
   lisaa_maali(i,apu1^.y,missile);
  end;
  if (apu1^.laji=kukka) and ((aika and $7f)=0) and (apu1^.explode=0) then
  begin
   i:=apu1^.x+6;
   if i>312 then i:=312;
   lisaa_maali(i,apu1^.y,pallo);
  end;
  apu1:=apu2;
 end;
end;

procedure pommita;
var apu:maalilista;
begin
 apu:=viholliset;
 while apu<>NIL do
 begin
  if apu^.laji IN [bomber,paha] then
   if (apu^.explode=0) and (abs(apu^.x-x_laiva)<20) then
    lisaa_ammus(pommit,apu^.x,apu^.y+apu^.korkeus,false);
  apu:=apu^.next;
 end;
end;

procedure piirra_tahti(x,y:integer);
begin
 outchar('*',x,y,$1f);
end;

procedure lue_vihut;
begin
 assign(vihupic,'vihu.pic');
 file2image(vihupic,vihukuva[vihu]);
 close(vihupic);
 sakot[vihu]:=1;
 kertoimet[vihu]:=1;
 korkeudet[vihu]:=5;
 assign(vihupic,'lyvihu.pic');
 file2image(vihupic,vihukuva[alyvihu]);
 close(vihupic);
 sakot[alyvihu]:=2;
 kertoimet[alyvihu]:=3;
 korkeudet[alyvihu]:=7;
 assign(vihupic,'bomber.pic');
 file2image(vihupic,vihukuva[bomber]);
 close(vihupic);
 sakot[bomber]:=2;
 kertoimet[bomber]:=5;
 korkeudet[bomber]:=5;
 assign(vihupic,'paha.pic');
 file2image(vihupic,vihukuva[paha]);
 close(vihupic);
 sakot[paha]:=5;
 kertoimet[paha]:=8;
 korkeudet[paha]:=7;
 assign(vihupic,'ammo.pic');
 file2image(vihupic,vihukuva[ase]);
 close(vihupic);
 sakot[ase]:=0;
 kertoimet[ase]:=0;
 korkeudet[ase]:=7;
 assign(vihupic,'missile.pic');
 file2image(vihupic,vihukuva[missile]);
 close(vihupic);
 sakot[missile]:=0;
 kertoimet[missile]:=12;
 korkeudet[missile]:=7;
 assign(vihupic,'pallo.pic');
 file2image(vihupic,vihukuva[pallo]);
 close(vihupic);
 sakot[pallo]:=5;
 kertoimet[pallo]:=16;
 korkeudet[pallo]:=7;
 assign(vihupic,'kukka.pic');
 file2image(vihupic,vihukuva[kukka]);
 close(vihupic);
 sakot[kukka]:=10;
 kertoimet[kukka]:=20;
 korkeudet[kukka]:=7;
 assign(vihupic,'panssari.pic');
 file2image(vihupic,vihukuva[panssari]);
 close(vihupic);
 sakot[panssari]:=8;
 kertoimet[panssari]:=25;
 korkeudet[panssari]:=7;
 assign(vihupic,'ohjus.pic');
 file2image(vihupic,ohjuskuva);
 close(vihupic);
end;

{$F+}
{$S-}
procedure oma_exit;
begin
 exitproc:=old_exit_proc;
 setintvec($09,@vanhanappis);
 tekstitila;
end;
{$S+}
{$F-}

procedure alustus;
begin
 inigraf;
 randomize;
{ getmem(puskuri,65028);}
 puskuri:=memallocseg(65520);
 puskuriseg:=seg(puskuri^);
 tausta:=memallocseg(65520);
 taustaseg:=seg(tausta^);
{ puskuriseg:=$8f00;
 taustaseg:=$7f00;
 Heapend:=ptr($7eff,$000f);}
 aseta_puskuri(taustaseg);
 tayta_puskuri($00);
 lue_fontti('9x16T');
 isofontti:=fontti;
 lue_fontti('5x8');
 pikkufontti:=fontti;
 for maara:=1 to 35 do
  piirra_tahti(random(314),random(188));
 ruutu;
 breikki:=false;
 x_laiva:=160;
 paussi:=false;
 y_laiva:=196;
 ammo:=400;
 lapi:=0;
 pistemaara:=0;
 maara:=0;
 leimahdus:=0;
 leimahdusraja:=0;
 patit:=NIL;
 pommit:=NIL;
 gun_active:=true;
 lue_vihut;
 viholliset:=NIL;
 level:=0;
 assign(level_data,'level.dat');
 reset(level_data);
 readln(level_data);
end;

procedure esittely;
var vih:maalityyppi;i:integer;dummy:char;
begin
 aseta_puskuri(taustaseg);
 ruutu;
 aseta_puskuri(SegA000);
 aseta_fontti(isofontti,16,9);
 hightextXY(75,0,'Vihujen Vastaisku',2,$2c,$6d);
 aseta_fontti(pikkufontti,8,5);
 i:=30;
 outtextXY(10,i,'Tehtvnsi on pidtell vihulaisten maahanlasku-',$2f);
 i:=i+10;
 outtextXY(10,i,'joukkoja mahdollisimman pitkn. Yrit est',$2f);
 i:=i+10;
 outtextXY(10,i,'alusten pseminen alareunaan tykkitulella.',$2f);
 i:=i+10;
 outtextXY(10,i,'Liikuta tykkisi nuolinppimill sivuttain ja',$2f);
 i:=i+10;
 outtextXY(10,i,'laukaise se blankko-nppimell. Saat pisteit',$2f);
 i:=i+10;
 outtextXY(10,i,'tuhotuista aluksista tuhoamiskorkeuden mukaan,',$2f);
 i:=i+10;
 outtextXY(10,i,'kerroin * korkeus, miss kerroin riippuu tuhotun',$2f);
 i:=i+10;
 outtextXY(10,i,'aluksen tyypist ja korkeus vaihtelee 0 - 200. Osa',$2f);
 i:=i+10;
 outtextXY(10,i,'vastustajista osaa hiukan vistell ja osa',$2f);
 i:=i+10;
 outtextXY(10,i,'pommittaa sinua. Jos vastustajan pommi osuu',$2f);
 i:=i+10;
 outtextXY(10,i,'sinuun, menett 8 ammusta ja 500 pistett',$2f);
 i:=i+10;
 outtextXY(10,i,'jos vastustajan ohjus osuu sinuun menett 10-100',$2f);
 i:=i+10;
 outtextXY(10,i,'ammusta ja 100-1000 pistett. Jos ainakin 20 ',$2f);
 i:=i+10;
 outtextXY(10,i,'vihollisyksikk psee lpi, sota on hvitty. ',$2f);
 dummy:=readkey;
 aseta_puskuri(taustaseg);
 ruutu;
 aseta_puskuri(SegA000);
 aseta_fontti(isofontti,16,9);
 hightextXY(75,0,'Vihujen Vastaisku',2,$2c,$6d);
 aseta_fontti(pikkufontti,8,5);
 i:=30;
 outtextXY(10,i,'Ystvt lhettvt lisammuksia. Ole paikalla,',$2f);
 i:=i+10;
 outtextXY(10,i,'kun ammuslasti laskeutuu. Alareunan vrilliset ',$2f);
 i:=i+10;
 outtextXY(10,i,'palkit kertovat ammustilanteen (violetti) ja',$2f);
 i:=i+10;
 outtextXY(10,i,'lpipsseiden yksikiden mrn (keltainen).',$2f);
 i:=i+10;
 outtextXY(10,i,'Jos siis violetti palkki lyhenee, ovat ammukset',$2f);
 i:=i+10;
 outtextXY(10,i,'loppumassa. Jos taas keltainen palkki lyhenee, ei',$2f);
 i:=i+10;
 outtextXY(10,i,'en ole varaa pst vastustajan aluksia lpi.',$2f);
 i:=i+10;
 outtextXY(10,i,'Sota on jaettu 10 eri taisteluun. Kunkin kahakan',$2f);
 i:=i+10;
 outtextXY(10,i,'jlkeen saat bonuspisteit ja lisammuksia. Kaha-',$2f);
 i:=i+10;
 outtextXY(10,i,'koiden vlill lpipsseet vihulaiset tuhotaan,',$2f);
 i:=i+10;
 outtextXY(10,i,'mutta tuhoaminen vhent lisammustesi mr.',$2f);
 i:=i+10;
 outtextXY(10,i,'Huomaa, ett ammuksesi eivt pse vihollisalusten',$2f);
 i:=i+10;
 outtextXY(10,i,'rjhdyspilven avaruusromun lpi! M-nppimell',$2f);
 i:=i+10;
 outtextXY(10,i,'voit laukaista tehokkaamman ohjuksen, joka tuhoaa',$2f);
 i:=i+10;
 outtextXY(10,i,'vihollisaluksia laajalta alueelta.',$2f);
 dummy:=readkey;
 aseta_puskuri(taustaseg);
 ruutu;
 aseta_puskuri(SegA000);
 aseta_fontti(isofontti,16,9);
 hightextXY(60,10,'Tietoa Alustyypeist',2,$2c,$6d);
 aseta_fontti(pikkufontti,8,5);
 i:=40;
 vih:=vihu;
 movnz_piirra(5,i,vihukuva[vih]);
 outtextXY(25,i,'Alkeellisin alus, tuo 1 yksikn, ei osaa vist',$2f);
 i:=i+10;
 outtextXY(25,i,'eik pommittaa, kerroin = 1',$2f);
 inc(vih);
 i:=i+15;
 movnz_piirra(5,i,vihukuva[vih]);
 outtextXY(25,i,'Alus, joka tuo 2 yksikk, osaa hiukan vistell',$2f);
 i:=i+10;
 outtextXY(25,i,'mutta ei pommittaa, kerroin = 3',$2f);
 inc(vih);
 i:=i+15;
 movnz_piirra(5,i,vihukuva[vih]);
 outtextXY(25,i,'Alus, joka tuo 2 yksikk, ei osaa vistell, ',$2f);
 i:=i+10;
 outtextXY(25,i,'mutta pommittaa sinua, kerroin = 5',$2f);
 inc(vih);
 i:=i+15;
 movnz_piirra(5,i,vihukuva[vih]);
 outtextXY(25,i,'Alus, joka tuo 5 yksikk, osaa hiukan vistell',$2f);
 i:=i+10;
 outtextXY(25,i,'ja pommittaa mys sinua, kerroin = 8',$2f);
 inc(vih);
 i:=i+15;
 movnz_piirra(5,i,vihukuva[vih]);
 outtextXY(25,i,'Ystviesi lhettm lisammusvarasto',$2f);
 inc(vih);
 dummy:=readkey;
 aseta_puskuri(taustaseg);
 ruutu;
 aseta_puskuri(SegA000);
 aseta_fontti(isofontti,16,9);
 hightextXY(60,10,'Tietoa Alustyypeist',2,$2c,$6d);
 aseta_fontti(pikkufontti,8,5);
 i:=40;
 movnz_piirra(5,i,vihukuva[vih]);
 outtextXY(25,i,'Tutkaohjattu miehittmtn ohjus, joka liikkuu ',$2f);
 i:=i+10;
 outtextXY(25,i,'sinua seuraten varsin nopeasti, kerroin = 12. ',$2f);
 i:=i+10;
 outtextXY(25,i,'Vaarallinen viel juuri rjhdettynkin!!',$2f);
 inc(vih);
 i:=i+15;
 movnz_piirra(5,i,vihukuva[vih]);
 outtextXY(25,i,'5 yksikk tuova vistelev alus, joka laukaisee',$2f);
 i:=i+10;
 outtextXY(25,i,'tasaisin vliajoin ohjuksen, kerroin =16',$2f);
 i:=i+15;
 inc(vih);
 movnz_piirra(5,i,vihukuva[vih]);
 outtextXY(25,i,'10 yksikk tuova alus, tuo hyperavaruudesta',$2f);
 i:=i+10;
 outtextXY(25,i,'ohjusten laukaisualustoja, vistelee hiukan,',$2f);
 i:=i+10;
 outtextXY(25,i,'kerroin = 25',$2f);
 inc(vih);
 i:=i+15;
 movnz_piirra(5,i,vihukuva[vih]);
 outtextXY(25,i,'8 yksikk tuova panssaroitu alus, laukaisee',$2f);
 i:=i+10;
 outtextXY(25,i,'ohjuksia ja vistelee, vaatii 5 osumaa ennen kuin',$2f);
 i:=i+10;
 outtextXY(25,i,'rjht, kerroin =25',$2f);
 dummy:=readkey;
end;

procedure valeur(s:string;var arvo:integer;var koodi:integer);
begin
 while (length(s)>0) and (s[length(s)]=' ') do
 begin
  s:=copy(s,1,length(s)-1);
 end;
 val(s,arvo,koodi);
 if koodi<>0 then arvo:=100;
end;

procedure lue_level;
var s1,s2:string[30]; koodi:integer; laatu:maalityyppi;
begin
 inc(level);
 repeat
  readln(level_data,s1);
  s2:=copy(s1,13,length(s1)-12);
  if pos('arpa',s1)>0 then
  begin
   valeur(s2,arparaja,koodi);
   for laatu:=vihu to sydan do
    arvat[laatu]:=arparaja;
  end;
  if pos('limit',s1)>0 then valeur(s2,raja,koodi);
  if pos('aly',s1)>0 then valeur(s2,arvat[alyvihu],koodi);
  if pos('bomb',s1)>0 then valeur(s2,arvat[bomber],koodi);
  if pos('paha',s1)>0 then valeur(s2,arvat[paha],koodi);
  if pos('ase',s1)>0 then valeur(s2,arvat[ase],koodi);
  if pos('miss',s1)>0 then valeur(s2,arvat[missile],koodi);
  if pos('pall',s1)>0 then valeur(s2,arvat[pallo],koodi);
  if pos('kukka',s1)>0 then valeur(s2,arvat[kukka],koodi);
  if pos('pans',s1)>0 then valeur(s2,arvat[panssari],koodi);
  if pos('luisk',s1)>0 then valeur(s2,arvat[luiska],koodi);
  if pos('syd',s1)>0 then valeur(s2,arvat[sydan],koodi);
  if pos('ammob',s1)>0 then valeur(s2,ammobonus,koodi);
  if pos('pisteb',s1)>0 then val(s2,pistebonus,koodi);
 until (pos('level',s1)>0) or eof(level_data);
end;

function arvo_vihu:maalityyppi;
var valitsin:integer; apu1,apu2:maalityyppi;
begin
 valitsin:=1+random(arparaja);
 apu1:=vihu;
 for apu2:=alyvihu to sydan do
  if (valitsin>arvat[apu2]) then apu1:=apu2;
 arvo_vihu:=apu1;
end;

procedure flush;
var dummy:char;
begin
 while keypressed do
 begin
  dummy:=readkey;
 end;
end;

begin
 GetIntVec($09,@vanhanappis);
 old_exit_proc:=exitproc;
 exitproc:=@oma_exit;
 alustus;
 esittely;
 repeat
  SetIntVec($09,Addr(omanappis));
  lue_level;
  piirra_tilanne;
  repeat
   aika:=mem[seg0040:$006c];
   if ((aika and $3f)=0) and (maara<raja) then
   begin
    lisaa_maali(20+2*random(140),0,arvo_vihu);
    inc(maara);
   end;
   if ((aika and $7f)=0) then uudet;
   kelaa_patit(patit);
   kelaa_pommit(pommit);
   if l_vasen then
   begin
    x_laiva:=x_laiva-2;
    if x_laiva<6 then x_laiva:=6;
   end;
   if l_oikea then
   begin
    x_laiva:=x_laiva+2;
    if x_laiva>312 then x_laiva:=312;
   end;
   if (aika and $07)=0 then pommita;
   liikuta;
   poista_maalit;
   piirra_tilanne;
   if leimahdus>0 then inc(leimahdus);
   if leimahdus=leimahdusraja then leimahdus:=0;
   repeat until (aika<>mem[seg0040:$006c]) and (not paussi);
  until breikki or (lapi>=vihulimit) or ((maara=raja) and (viholliset=NIL) and (patit=NIL));
  SetIntVec($09,@vanhanappis);
  flush;
  if not (breikki or (lapi>=vihulimit)) then
  begin
   ammo:=ammo+ammobonus-5*lapi;
   if ammo>2000 then ammo:=2000;
   if ammo<0 then ammo:=0;
   pistemaara:=pistemaara+pistebonus;
   aseta_puskuri(taustaseg);
   ruutu;
   aseta_fontti(pikkufontti,8,5);
   aseta_puskuri(SegA000);
   str(level:2,tulos);
   tulos:='Taso '+tulos+' selvitetty';
   outtextXY(40,60,tulos,$2c);
   outtextXY(40,80,'Helppo kahakka, vai mit',$2c);
   if lapi>0 then outtextXY(40,100,'Toverisi tuhosivat lpi psseet yksikt',$2c);
   if not eof(level_data) then
    outtextXY(40,120,'Aika valmistautua seuraavaan taisteluun',$2c);
   delay(2000);
   aika:=ord(readkey);
   viholliset:=NIL;
   patit:=NIL;
   pommit:=NIL;
   lapi:=0;
   maara:=0;
   leimahdus:=0;
  end;
 until breikki or (lapi>=vihulimit) or eof(level_data);
 tayta_puskuri($00);
 str(pistemaara:7,tulos);
 outtextXY(80,80,'Pistemrsi on '+tulos,$2c);
 if eof(level_data) and (not (breikki or (lapi>=vihulimit))) then
  outtextXY(80,120,'Olet torjunut vihujen vastaiskun',$2f);
 delay(2500);
 tekstitila;
 close(level_data);
 flush;
end.
